# std::set< _Key, _Compare, _Alloc > Class Template Reference
[Associative Containers]

A standard container made up of unique keys, which can be retrieved in logarithmic time. More...

List of all members.

## Public Types

- typedef _Alloc allocator_type
- typedef _Compare key_compare
- typedef _Key key_type
- typedef _Compare value_compare
- typedef _Key value_type

- typedef _Rep_type::const_iterator const_iterator
- typedef
  _Key_alloc_type::const_pointer const_pointer
- typedef
  _Key_alloc_type::const_reference const_reference
- typedef
  _Rep_type::const_reverse_iterator const_reverse_iterator
- typedef _Rep_type::difference_type difference_type
- typedef _Rep_type::const_iterator iterator
- typedef _Key_alloc_type::pointer pointer
- typedef _Key_alloc_type::reference reference
- typedef
  _Rep_type::const_reverse_iterator reverse_iterator
- typedef _Rep_type::size_type size_type

## Public Member Functions

- iterator begin () const
- iterator cbegin () const
- iterator cend () const
- void clear ()
- size_type count (const key_type &__x) const
- reverse_iterator crbegin () const
- reverse_iterator crend () const
- bool empty () const
- iterator end () const
- void erase (iterator __first, iterator __last)
- size_type erase (const key_type &__x)
- void erase (iterator __position)
- allocator_type get_allocator () const
- void insert (initializer_list< value_type > __l)
- template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
- iterator insert (iterator __position, const value_type &__x)
- std::pair< iterator, bool > insert (const value_type &__x)
- key_compare key_comp () const
- size_type max_size () const
- set & operator= (initializer_list< value_type > __l)
- set & operator= (set &&__x)
- set & operator= (const set &__x)
- reverse_iterator rbegin () const
- reverse_iterator rend () const
- set (initializer_list< value_type > __l, const _Compare &__comp=_Compare(), const allocator_type &__a=allocator_type())
- set (set &&__x)
- set (const set &__x)
- template<typename _InputIterator > set (_InputIterator __first, _InputIterator __last, const _Compare &__comp, const allocator_type &__a=allocator_type())
- template<typename _InputIterator > set (_InputIterator __first, _InputIterator __last)
- set (const _Compare &__comp, const allocator_type &__a=allocator_type())
- set ()
- size_type size () const
- void swap (set &&__x)
- value_compare value_comp () const

- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__x) const
- std::pair< iterator, iterator > equal_range (const key_type &__x)

- const_iterator find (const key_type &__x) const
- iterator find (const key_type &__x)

- const_iterator lower_bound (const key_type &__x) const
- iterator lower_bound (const key_type &__x)

- const_iterator upper_bound (const key_type &__x) const
- iterator upper_bound (const key_type &__x)

## Friends

- template<typename _K1 , typename _C1 , typename _A1 > bool operator< (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)
- template<typename _K1 , typename _C1 , typename _A1 > bool operator== (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)

## Detailed Description

### template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
class std::set< _Key, _Compare, _Alloc >

A standard container made up of unique keys, which can be retrieved in logarithmic time.

Meets the requirements of a container, a reversible container, and an associative container (using unique keys).

Sets support bidirectional iterators.

Parameters:

  | Key | Type of key objects.
  | Compare | Comparison function object type, defaults to less<Key>.
  | Alloc | Allocator type, defaults to allocator<Key>.

The private tree data is declared exactly the same way for set and multiset; the distinction is made entirely in how the tree functions are called (*_unique versus *_equal, same as the standard).

Definition at line 87 of file stl_set.h.

## Member Typedef Documentation

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Alloc std::set< _Key, _Compare, _Alloc >::allocator_type

Public typedefs.

Definition at line 104 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_iterator std::set< _Key, _Compare, _Alloc >::const_iterator

Iterator-related typedefs.

Definition at line 125 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key_alloc_type::const_pointer std::set< _Key, _Compare, _Alloc >::const_pointer

Iterator-related typedefs.

Definition at line 118 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key_alloc_type::const_reference std::set< _Key, _Compare, _Alloc >::const_reference

Iterator-related typedefs.

Definition at line 120 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_reverse_iterator std::set< _Key, _Compare, _Alloc >::const_reverse_iterator

Iterator-related typedefs.

Definition at line 127 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::difference_type std::set< _Key, _Compare, _Alloc >::difference_type

Iterator-related typedefs.

Definition at line 129 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_iterator std::set< _Key, _Compare, _Alloc >::iterator

Iterator-related typedefs.

Definition at line 124 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Compare std::set< _Key, _Compare, _Alloc >::key_compare

Public typedefs.

Definition at line 102 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key std::set< _Key, _Compare, _Alloc >::key_type

Public typedefs.

Definition at line 100 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key_alloc_type::pointer std::set< _Key, _Compare, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 117 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key_alloc_type::reference std::set< _Key, _Compare, _Alloc >::reference

Iterator-related typedefs.

Definition at line 119 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::const_reverse_iterator std::set< _Key, _Compare, _Alloc >::reverse_iterator

Iterator-related typedefs.

Definition at line 126 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Rep_type::size_type std::set< _Key, _Compare, _Alloc >::size_type

Iterator-related typedefs.

Definition at line 128 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Compare std::set< _Key, _Compare, _Alloc >::value_compare

Public typedefs.

Definition at line 103 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

typedef _Key std::set< _Key, _Compare, _Alloc >::value_type

Public typedefs.

Definition at line 101 of file stl_set.h.

## Constructor & Destructor Documentation

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::set< _Key, _Compare, _Alloc >::set | ( |  | ) | `[inline]`

Default constructor creates no elements.

Definition at line 136 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::set< _Key, _Compare, _Alloc >::set | ( | const _Compare & | __comp,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline, explicit]`

Creates a set with no elements.

Parameters:

  | comp | Comparator to use.
  | a | An allocator object.

Definition at line 145 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator >

std::set< _Key, _Compare, _Alloc >::set | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Builds a set from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.

Create a set consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 159 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator >

std::set< _Key, _Compare, _Alloc >::set | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a set from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a set consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Definition at line 175 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::set< _Key, _Compare, _Alloc >::set | ( | const set< _Key, _Compare, _Alloc > & | __x | ) | `[inline]`

Set copy constructor.

Parameters:

  | x | A set of identical element and allocator types.

The newly-created set uses a copy of the allocation object used by x.

Definition at line 188 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::set< _Key, _Compare, _Alloc >::set | ( | set< _Key, _Compare, _Alloc > && | __x | ) | `[inline]`

Set move constructor

Parameters:

  | x | A set of identical element and allocator types.

The newly-created set contains the exact contents of x. The contents of x are a valid, but unspecified set.

Definition at line 199 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::set< _Key, _Compare, _Alloc >::set | ( | initializer_list< value_type > | __l,
|  | const _Compare & | __comp = `_Compare()`,
|  | const allocator_type & | __a = `allocator_type()` |
| ) |  |  | `[inline]`

Builds a set from an initializer_list.

Parameters:

  | l | An initializer_list.
  | comp | A comparison functor.
  | a | An allocator object.

Create a set consisting of copies of the elements in the list. This is linear in N if the list is already sorted, and NlogN otherwise (where N is l.size()).

Definition at line 212 of file stl_set.h.

References std::initializer_list< _E >::begin(), and std::initializer_list< _E >::end().

## Member Function Documentation

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the set. Iteration is done in ascending order according to the keys.

Definition at line 291 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::cbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first element in the set. Iteration is done in ascending order according to the keys.

Definition at line 328 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::cend | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the set. Iteration is done in ascending order according to the keys.

Definition at line 337 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::set< _Key, _Compare, _Alloc >::clear | ( |  | ) | `[inline]`

Erases all elements in a set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 515 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::set< _Key, _Compare, _Alloc >::count | ( | const key_type & | __x | ) | const`[inline]`

Finds the number of elements.

Parameters:

  | x | Element to located.

Returns:
  Number of elements with specified key.

This function only makes sense for multisets; for set the result will either be 0 (not present) or 1 (present).

Definition at line 529 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::set< _Key, _Compare, _Alloc >::crbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the last element in the set. Iteration is done in descending order according to the keys.

Definition at line 346 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::set< _Key, _Compare, _Alloc >::crend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last pair in the set. Iteration is done in descending order according to the keys.

Definition at line 355 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

bool std::set< _Key, _Compare, _Alloc >::empty | ( |  | ) | const`[inline]`

Returns true if the set is empty.

Definition at line 361 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last element in the set. Iteration is done in ascending order according to the keys.

Definition at line 300 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::pair<const_iterator, const_iterator> std::set< _Key, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | const`[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 613 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::pair<iterator, iterator> std::set< _Key, _Compare, _Alloc >::equal_range | ( | const key_type & | __x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Definition at line 609 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::set< _Key, _Compare, _Alloc >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  | `[inline]`

Erases a [first,last) range of elements from a set.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 505 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::set< _Key, _Compare, _Alloc >::erase | ( | const key_type & | __x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all the elements located by the given key from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 490 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::set< _Key, _Compare, _Alloc >::erase | ( | iterator | __position | ) | `[inline]`

Erases an element from a set.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 475 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::set< _Key, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | const`[inline]`

Tries to locate an element in a set.

Parameters:

  | x | Element to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 551 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::find | ( | const key_type & | __x | ) | `[inline]`

Tries to locate an element in a set.

Parameters:

  | x | Element to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Definition at line 547 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

allocator_type std::set< _Key, _Compare, _Alloc >::get_allocator | ( |  | ) | const`[inline]`

Returns the allocator object with which the set was constructed.

Definition at line 282 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::set< _Key, _Compare, _Alloc >::insert | ( | initializer_list< value_type > | __l | ) | `[inline]`

Attempts to insert a list of elements into the set.

Parameters:

  | list | A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 461 of file stl_set.h.

References std::initializer_list< _E >::begin(), std::initializer_list< _E >::end(), and std::set< _Key, _Compare, _Alloc >::insert().

Referenced by std::set< _Key, _Compare, _Alloc >::insert().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>
template<typename _InputIterator >

void std::set< _Key, _Compare, _Alloc >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

A template function that attempts to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 449 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  | `[inline]`

Attempts to insert an element into the set.

Parameters:

  | position | An iterator that serves as a hint as to where the element should be inserted.
  | x | Element to be inserted.

Returns:
  An iterator that points to the element with key of x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on "hinting", see: http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt07ch17.html

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 435 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

std::pair<iterator, bool> std::set< _Key, _Compare, _Alloc >::insert | ( | const value_type & | __x | ) | `[inline]`

Attempts to insert an element into the set.

Parameters:

  | x | Element to be inserted.

Returns:
  A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the set. A set relies on unique keys and thus an element is only inserted if it is not already present in the set.

Insertion requires logarithmic time.

Definition at line 408 of file stl_set.h.

References std::pair< _T1, _T2 >::first, and std::pair< _T1, _T2 >::second.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

key_compare std::set< _Key, _Compare, _Alloc >::key_comp | ( |  | ) | const`[inline]`

Returns the comparison object with which the set was constructed.

Definition at line 274 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::set< _Key, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 572 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::lower_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Definition at line 568 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::set< _Key, _Compare, _Alloc >::max_size | ( |  | ) | const`[inline]`

Returns the maximum size of the set.

Definition at line 371 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

set& std::set< _Key, _Compare, _Alloc >::operator= | ( | initializer_list< value_type > | __l | ) | `[inline]`

Set list assignment operator.

Parameters:

  | l | An initializer_list.

This function fills a set with copies of the elements in the initializer list l.

Note that the assignment completely changes the set and that the resulting set's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 262 of file stl_set.h.

References std::initializer_list< _E >::begin(), and std::initializer_list< _E >::end().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

set& std::set< _Key, _Compare, _Alloc >::operator= | ( | set< _Key, _Compare, _Alloc > && | __x | ) | `[inline]`

Set move assignment operator.

Parameters:

  | x | A set of identical element and allocator types.

The contents of x are moved into this set (without copying). x is a valid, but unspecified set.

Definition at line 242 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

set& std::set< _Key, _Compare, _Alloc >::operator= | ( | const set< _Key, _Compare, _Alloc > & | __x | ) | `[inline]`

Set assignment operator.

Parameters:

  | x | A set of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Definition at line 227 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::set< _Key, _Compare, _Alloc >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the last element in the set. Iteration is done in descending order according to the keys.

Definition at line 309 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

reverse_iterator std::set< _Key, _Compare, _Alloc >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last pair in the set. Iteration is done in descending order according to the keys.

Definition at line 318 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

size_type std::set< _Key, _Compare, _Alloc >::size | ( |  | ) | const`[inline]`

Returns the size of the set.

Definition at line 366 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

void std::set< _Key, _Compare, _Alloc >::swap | ( | set< _Key, _Compare, _Alloc > && | __x | ) | `[inline]`

Swaps data with another set.

Parameters:

  | x | A set of the same element and allocator types.

This exchanges the elements between two sets in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 387 of file stl_set.h.

Referenced by std::swap().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

const_iterator std::set< _Key, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | const`[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 588 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

iterator std::set< _Key, _Compare, _Alloc >::upper_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Definition at line 584 of file stl_set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Alloc = std::allocator<_Key>>

value_compare std::set< _Key, _Compare, _Alloc >::value_comp | ( |  | ) | const`[inline]`

Returns the comparison object with which the set was constructed.

Definition at line 278 of file stl_set.h.

The documentation for this class was generated from the following file:

- stl_set.h